package com.ruoyi.system.domain.form;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class MdFormTemplateExample implements Serializable {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public MdFormTemplateExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andNameIsNull() {
            addCriterion("name is null");
            return (Criteria) this;
        }

        public Criteria andNameIsNotNull() {
            addCriterion("name is not null");
            return (Criteria) this;
        }

        public Criteria andNameEqualTo(String value) {
            addCriterion("name =", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotEqualTo(String value) {
            addCriterion("name <>", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThan(String value) {
            addCriterion("name >", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThanOrEqualTo(String value) {
            addCriterion("name >=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThan(String value) {
            addCriterion("name <", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThanOrEqualTo(String value) {
            addCriterion("name <=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLike(String value) {
            value = "%"+value+"%";
            addCriterion("name like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotLike(String value) {
            addCriterion("name not like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameIn(List<String> values) {
            addCriterion("name in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotIn(List<String> values) {
            addCriterion("name not in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameBetween(String value1, String value2) {
            addCriterion("name between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotBetween(String value1, String value2) {
            addCriterion("name not between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andImgIsNull() {
            addCriterion("img is null");
            return (Criteria) this;
        }

        public Criteria andImgIsNotNull() {
            addCriterion("img is not null");
            return (Criteria) this;
        }

        public Criteria andImgEqualTo(String value) {
            addCriterion("img =", value, "img");
            return (Criteria) this;
        }

        public Criteria andImgNotEqualTo(String value) {
            addCriterion("img <>", value, "img");
            return (Criteria) this;
        }

        public Criteria andImgGreaterThan(String value) {
            addCriterion("img >", value, "img");
            return (Criteria) this;
        }

        public Criteria andImgGreaterThanOrEqualTo(String value) {
            addCriterion("img >=", value, "img");
            return (Criteria) this;
        }

        public Criteria andImgLessThan(String value) {
            addCriterion("img <", value, "img");
            return (Criteria) this;
        }

        public Criteria andImgLessThanOrEqualTo(String value) {
            addCriterion("img <=", value, "img");
            return (Criteria) this;
        }

        public Criteria andImgLike(String value) {
            addCriterion("img like", value, "img");
            return (Criteria) this;
        }

        public Criteria andImgNotLike(String value) {
            addCriterion("img not like", value, "img");
            return (Criteria) this;
        }

        public Criteria andImgIn(List<String> values) {
            addCriterion("img in", values, "img");
            return (Criteria) this;
        }

        public Criteria andImgNotIn(List<String> values) {
            addCriterion("img not in", values, "img");
            return (Criteria) this;
        }

        public Criteria andImgBetween(String value1, String value2) {
            addCriterion("img between", value1, value2, "img");
            return (Criteria) this;
        }

        public Criteria andImgNotBetween(String value1, String value2) {
            addCriterion("img not between", value1, value2, "img");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("status is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("status is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("status =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("status <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("status >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("status >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("status <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("status <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("status in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("status not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("status between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("status not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Long value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Long value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Long value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Long value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Long value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Long value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Long> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Long> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Long value1, Long value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Long value1, Long value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andOwnUserIsNull() {
            addCriterion("own_user is null");
            return (Criteria) this;
        }

        public Criteria andOwnUserIsNotNull() {
            addCriterion("own_user is not null");
            return (Criteria) this;
        }

        public Criteria andOwnUserEqualTo(String value) {
            addCriterion("own_user =", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserNotEqualTo(String value) {
            addCriterion("own_user <>", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserGreaterThan(String value) {
            addCriterion("own_user >", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserGreaterThanOrEqualTo(String value) {
            addCriterion("own_user >=", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserLessThan(String value) {
            addCriterion("own_user <", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserLessThanOrEqualTo(String value) {
            addCriterion("own_user <=", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserLike(String value) {
            addCriterion("own_user like", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserNotLike(String value) {
            addCriterion("own_user not like", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserIn(List<String> values) {
            addCriterion("own_user in", values, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserNotIn(List<String> values) {
            addCriterion("own_user not in", values, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserBetween(String value1, String value2) {
            addCriterion("own_user between", value1, value2, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserNotBetween(String value1, String value2) {
            addCriterion("own_user not between", value1, value2, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnDeptIsNull() {
            addCriterion("own_dept is null");
            return (Criteria) this;
        }

        public Criteria andOwnDeptIsNotNull() {
            addCriterion("own_dept is not null");
            return (Criteria) this;
        }

        public Criteria andOwnDeptEqualTo(String value) {
            addCriterion("own_dept =", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptNotEqualTo(String value) {
            addCriterion("own_dept <>", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptGreaterThan(String value) {
            addCriterion("own_dept >", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptGreaterThanOrEqualTo(String value) {
            addCriterion("own_dept >=", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptLessThan(String value) {
            addCriterion("own_dept <", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptLessThanOrEqualTo(String value) {
            addCriterion("own_dept <=", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptLike(String value) {
            addCriterion("own_dept like", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptNotLike(String value) {
            addCriterion("own_dept not like", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptIn(List<String> values) {
            addCriterion("own_dept in", values, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptNotIn(List<String> values) {
            addCriterion("own_dept not in", values, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptBetween(String value1, String value2) {
            addCriterion("own_dept between", value1, value2, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptNotBetween(String value1, String value2) {
            addCriterion("own_dept not between", value1, value2, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnInsIsNull() {
            addCriterion("own_ins is null");
            return (Criteria) this;
        }

        public Criteria andOwnInsIsNotNull() {
            addCriterion("own_ins is not null");
            return (Criteria) this;
        }

        public Criteria andOwnInsEqualTo(String value) {
            addCriterion("own_ins =", value, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsNotEqualTo(String value) {
            addCriterion("own_ins <>", value, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsGreaterThan(String value) {
            addCriterion("own_ins >", value, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsGreaterThanOrEqualTo(String value) {
            addCriterion("own_ins >=", value, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsLessThan(String value) {
            addCriterion("own_ins <", value, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsLessThanOrEqualTo(String value) {
            addCriterion("own_ins <=", value, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsLike(String value) {
            addCriterion("own_ins like", value, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsNotLike(String value) {
            addCriterion("own_ins not like", value, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsIn(List<String> values) {
            addCriterion("own_ins in", values, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsNotIn(List<String> values) {
            addCriterion("own_ins not in", values, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsBetween(String value1, String value2) {
            addCriterion("own_ins between", value1, value2, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnInsNotBetween(String value1, String value2) {
            addCriterion("own_ins not between", value1, value2, "ownIns");
            return (Criteria) this;
        }

        public Criteria andOwnGovIsNull() {
            addCriterion("own_gov is null");
            return (Criteria) this;
        }

        public Criteria andOwnGovIsNotNull() {
            addCriterion("own_gov is not null");
            return (Criteria) this;
        }

        public Criteria andOwnGovEqualTo(String value) {
            addCriterion("own_gov =", value, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovNotEqualTo(String value) {
            addCriterion("own_gov <>", value, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovGreaterThan(String value) {
            addCriterion("own_gov >", value, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovGreaterThanOrEqualTo(String value) {
            addCriterion("own_gov >=", value, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovLessThan(String value) {
            addCriterion("own_gov <", value, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovLessThanOrEqualTo(String value) {
            addCriterion("own_gov <=", value, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovLike(String value) {
            addCriterion("own_gov like", value, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovNotLike(String value) {
            addCriterion("own_gov not like", value, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovIn(List<String> values) {
            addCriterion("own_gov in", values, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovNotIn(List<String> values) {
            addCriterion("own_gov not in", values, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovBetween(String value1, String value2) {
            addCriterion("own_gov between", value1, value2, "ownGov");
            return (Criteria) this;
        }

        public Criteria andOwnGovNotBetween(String value1, String value2) {
            addCriterion("own_gov not between", value1, value2, "ownGov");
            return (Criteria) this;
        }

        public Criteria andCategoryIdIsNull() {
            addCriterion("category_id is null");
            return (Criteria) this;
        }

        public Criteria andCategoryIdIsNotNull() {
            addCriterion("category_id is not null");
            return (Criteria) this;
        }

        public Criteria andCategoryIdEqualTo(String value) {
            addCriterion("category_id =", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotEqualTo(String value) {
            addCriterion("category_id <>", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdGreaterThan(String value) {
            addCriterion("category_id >", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdGreaterThanOrEqualTo(String value) {
            addCriterion("category_id >=", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdLessThan(String value) {
            addCriterion("category_id <", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdLessThanOrEqualTo(String value) {
            addCriterion("category_id <=", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdLike(String value) {
            addCriterion("category_id like", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotLike(String value) {
            addCriterion("category_id not like", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdIn(List<String> values) {
            addCriterion("category_id in", values, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotIn(List<String> values) {
            addCriterion("category_id not in", values, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdBetween(String value1, String value2) {
            addCriterion("category_id between", value1, value2, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotBetween(String value1, String value2) {
            addCriterion("category_id not between", value1, value2, "categoryId");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}